// GenoSet.h: interface for the GenoSet class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _GENOSET_
#define _GENOSET_

#include <vector>
#include <fstream>
#include <iostream>
#include "genotype.h"
using namespace std;

typedef vector<genotype*>::iterator  genoit;
typedef vector<genotype*>::const_iterator  const_genoit;

//encapsulate a vector of genotype*
class GenoSet  
{
public:	
	void searchResolve();
	int greedyResolve();
	void sortBy2();
	bool cover1(haplotype& h, genotype * g);
	bool cover2(haplotype &h, genotype * g1, genotype * g2);
	void setPreRelation();
	void setHrelation(haplotype & h, bool first = false);
	void setH2relation(haplotype &h1, haplotype & h2, genotype * g1, genotype * g2);
	void buildGHgraph();
	void preResolve();
	void delGenotypes();
	void print(ostream & os, bool bCut=true);
	void cutSNP();
	void readFile(ifstream& genofile);
	void printSolution(vector<haplotype *> & solution);
	GenoSet();
	virtual ~GenoSet();

	vector<genotype*> m_gvec;	
};

void copyHset(vector<haplotype*>& news, set<const haplotype*>& s);
void delHset(vector<haplotype*>& s);

#endif 
