// HaploSet.cpp: implementation of the HaploSet class.
//
//////////////////////////////////////////////////////////////////////

#include "HaploSet.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HaploSet::HaploSet()
{

}

HaploSet::~HaploSet()
{
	m_hset.clear();
}


void HaploSet::debug()
{
	//test operation of hapset
	haplotype h1;	
	h1.getPosition(5);
	//h1.addRelation (make_pair(10, &h1));
	h1.setPosition(7, 1);
	insert(h1);
	
	h1.setPosition(6, 1);
	print(cout);	
	insert(h1);
	print(cout);	
	h1.setPosition(6, 0);
	//h1.addRelation (make_pair(6, &h1));
	insert(h1);	
	print(cout);	
	m_hset.erase (h1);
	insert(h1);	
	print(cout);	

	haplotype h2;
	h2.setPosition (6,1);
	hapit it=m_hset.find (h2);
	if(it!=m_hset.end())
		cout << "find 6" << endl;
	h2.setPosition (7, 1);
	it=m_hset.find (h2);
	if(it!=m_hset.end())
		cout << "find 6,7" << endl;	
}

const haplotype* HaploSet::insert(haplotype& h)
{
	h.m_index =m_hset.size();
	pair<hapit, bool> p =m_hset.insert (h);
	//if(!p.second)	return false;	
	return &(*(p.first));
}

void HaploSet::print(ostream &os, bool bCut)	{
	os << "Haplotypes " << m_hset.size();
	if(bCut)	os << " (compact)" << endl;
	else		os << " (full length)" << endl;
	hapit it;
	for(it=m_hset.begin(); it!=m_hset.end(); it++)	
		if(bCut)	os << *it << endl;
		else	{
			(*it).printSeq(os, false);
			os<< endl;
		}
	return;
}

//find a given haplotype h in hapset. if not found, return null pointer
const haplotype * HaploSet::find(const haplotype &h)
{
	hapit it=m_hset.find(h);
	if(it!=m_hset.end())
		return &(*it);
	else
		return 0;
}
