// HaploSet.h: interface for the HaploSet class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _HAPLOSET_ 
#define _HAPLOSET_ 

#include <set>
#include <fstream>
#include <iostream>
#include "haplotype.h"
using namespace std;

typedef set<haplotype>::iterator  hapit;
typedef set<haplotype>::const_iterator  const_hapit;

//HaploSet encapsulates a set of haplotypes
class HaploSet  
{
public:
	const haplotype * find(const haplotype & h);
	const haplotype* insert(haplotype & h);
	HaploSet();
	virtual ~HaploSet();
	void debug();

	set<haplotype> m_hset;
	void print(ostream &os, bool bCut=true);

};

#endif 
