// genotype.h: interface for the genotype class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _GENOTYPE_
#define _GENOTYPE_

#include <list>
#include <fstream>
#include <iostream>
using namespace std;

class haplotype;

typedef pair<const haplotype*, const haplotype*> resolution;

class genotype  
{
public:	
	void addResolution(const haplotype *h1, const haplotype * h2);
	void printSeq(ostream& os, bool bCut=true);
	bool isContained(genotype & g);
	bool resolve(const haplotype & h);
	bool resolve(const haplotype & h1, haplotype & h2);
	int get2siteNum();
	genotype();
	virtual ~genotype();

	char * m_sequence;
	list<resolution> m_resolutions;
	int m_index, m_resolveState;		//m_resolveState: 2-unresolvable, 1-preresolved, 0-normal
};

ostream& operator <<(ostream &os, const genotype &g);

#endif 
