// int64.h: interface for the int64 class.
//
//////////////////////////////////////////////////////////////////////
#ifndef _HAPLOTYPE_
#define _HAPLOTYPE_

#include <fstream>
#include <iostream>
#include <list>
using namespace std;

class haplotype;
class genotype;

//typedef pair<genotype*, const haplotype*> relation;

class haplotype
{
public:
	int priority(const haplotype * h) const;
	void printSeq(ostream & os, bool bCut=true) const;
	haplotype(const haplotype& h);
	void addRelation(genotype * g);//void addRelation(const relation & r);
	haplotype& operator =(const haplotype &h);
	haplotype();
	virtual ~haplotype();
	
	//pos:0 ~ gLength-1. 0 is on the highest bit of the 1st char in m_sequence
	inline void setPosition(int pos, int i) //i=0,1; 	
	{
		if(i==1)	m_sequence[pos/8] |= 1<<(7-pos%8);
		else		m_sequence[pos/8] &= ~(1<<(7-pos%8));
		return;
	}
	
	inline bool getPosition(int pos) const		{
		return m_sequence[pos/8] & (1<<(7-pos%8));
	}	
	
	unsigned char * m_sequence;	
	list<genotype*> m_relation;//list<relation> m_relation;
	int m_index, m_coverage, m_priority;//init=0, the larger the better, homo 200, 1-hete 100, others: sum of coverage of pairh
	bool m_bChosen;  //, m_homo, m_bComplete, m_bAmbiguous;
	//in solution: m_bChosen- reliable? m_coverage-coverage in solution
};

ostream& operator <<(ostream &os, const haplotype &h);
istream& operator >>(istream &os, haplotype &h);
bool operator < (const haplotype &h1, const haplotype &h2);
bool operator == (const haplotype &h1, const haplotype &h2);

#endif
